<script lang="ts" setup>
/**
 * @Name: Table.vue
 * @Description: 商品列表表格
 * @Author: Cheney
 */

import { Download, Message, Money, Open, Refresh } from '@element-plus/icons-vue';
import { ElMessage } from 'element-plus';
import { usePagination } from '/@/utils/usePagination';
import { useTableData } from '/@/utils/useTableData';
import { productColumns } from '../ColumnsTsx';
import DataTableSlot from './DataTableSlot.vue';
import { downloadFile } from '/@/utils/service';
import PermissionButton from '/src/components/PermissionButton/index.vue';
import ImportButton from '/src/components/ImportButton/index.vue';
import VerticalDivider from '/src/components/VerticalDivider/index.vue';
import EditDrawer from '/src/views/product-manage/product-list/component/EditDrawer.vue';
import NoticeDialog from '/src/views/product-manage/product-list/component/NoticeDialog.vue';
import * as api from '../api';


interface Parameter {
  country: string,
  brand: string,
  group: string,
  status: string,
  asin: string,
  sku: string,
  shop: string,
}

const queryParameter: Parameter | undefined = inject('query-parameter');
const { tableOptions, handlePageChange } = usePagination(fetchList);

const gridRef = ref();
const gridOptions: any = reactive({
  size: 'mini',
  border: false,
  round: true,
  stripe: true,
  currentRowHighLight: true,
  height: '100%',
  toolbarConfig: {
    size: 'large',
    custom: true,
    slots: {
      buttons: 'toolbar_buttons',
      tools: 'toolbar_tools'
    }
  },
  rowConfig: {
    isHover: true
  },
  columnConfig: {
    resizable: true,
    useVirtual: true
  },
  pagerConfig: {
    total: tableOptions.value.total,
    page: tableOptions.value.page,
    limit: tableOptions.value.limit
  },
  loading: false,
  loadingConfig: {
    icon: 'vxe-icon-indicator roll',
    text: '正在拼命加载中...'
  },
  columns: '',
  data: ''
});

const checkedList = ref<Set<number>>(new Set());
const btnLoading = ref(false);

const editOpen = ref(false);
const rowData = ref({});

const dialogVisible = ref(false);

const templateType = ref('notice');

onMounted(() => {
  fetchList();
});

async function fetchList() {
  gridOptions.data = [];
  gridOptions.columns = [];

  const query = {
    country_code: queryParameter?.country,
    brand: queryParameter?.brand,
    tag: queryParameter?.group,
    status: queryParameter?.status,
    asin: queryParameter?.asin,
    sku: queryParameter?.sku,
    shop_id: queryParameter?.shop
  };

  await useTableData(api.getTableData, query, gridOptions);
  await gridRef.value.loadColumn(productColumns);
  gridOptions.showHeader = Boolean(gridOptions.data?.length);
}

function handleRefresh() {
  fetchList();
}

async function handleDownload() {
  const confirmed = await ElMessageBox.confirm('是否确认导出当前时间内所有数据项?', '警告', {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning'
  });

  if (confirmed) {
    gridOptions.loading = true;
    try {
      const query = {
        country_code: queryParameter?.country,
        brand: queryParameter?.brand,
        tag: queryParameter?.group,
        status: queryParameter?.status,
        asin: queryParameter?.asin,
        sku: queryParameter?.sku,
        shop_id: queryParameter?.shop
      };
      const response = await api.exportData(query);
      const url = window.URL.createObjectURL(new Blob([ response.data ]));
      const link = document.createElement('a');
      link.href = url;
      link.setAttribute('download', '商品列表数据.xlsx');
      document.body.appendChild(link);
      link.click();
      ElMessage.success('数据导出成功！');
    } catch (error) {
      ElMessage.error('数据导出失败，请重试！');
      console.error(error);
    } finally {
      gridOptions.loading = false; // 结束加载状态
    }
  }
}

function selectChangeEvent({ checked, row }: any) {
  if (checked) {
    checkedList.value.add(row.id); // 获取单个数据
  } else {
    checkedList.value.delete(row.id);
  }
}

function selectAllChangeEvent({ checked }: any) {
  const $grid = gridRef.value;
  if ($grid) {
    const records = $grid.getData(); // 获取所有数据
    if (checked) {
      records.forEach((item: any) => {
        checkedList.value.add(item.id);
      });
    } else {
      checkedList.value.clear();
    }
  }
}

function handleEdit(row: any) {
  editOpen.value = true;
  rowData.value = row;
}

function handleNotice(row: any) {
  dialogVisible.value = true;
  rowData.value = row;
}

async function switchMonitor(row: any) {
  const res = await useResponse(api.postMonitor, { ids: [ row.id ], status: row.is_monitor ? 1 : 0 });
  if (res && res.code === 2000) {
    ElMessage.success('操作成功!');
  } else {
    row.is_monitor = !row.is_monitor;
    ElMessage.error('操作失败!');
  }
}

async function batchOpen() {
  const ids = Array.from(checkedList.value);
  const res = await useResponse(api.postMonitor, { ids, status: 1 }, btnLoading);
  if (res && res.code === 2000) {
    ElMessage.success('操作成功!');
  }
  checkedList.value.clear();
  await fetchList();
}

function downloadTemplate() {
  const urlMap: { [key: string]: string } = {
    notice: '/api/choice/goods/alarm/import_data/',
    product: '/api/choice/goods/import_data/',
    price: '/api/choice/goods/GuidancePrice/import_data/'
  };

  const url = urlMap[templateType.value];
  if (url) {
    downloadFile({
      url,
      method: 'GET'
    });
  } else {
    console.error('未知的模板类型:', templateType.value);
  }
}

defineExpose({ fetchList });
</script>

<template>
  <vxe-grid ref="gridRef"
            v-bind="gridOptions"
            @checkbox-change="selectChangeEvent"
            @checkbox-all="selectAllChangeEvent">
    <!-- 工具栏左侧 -->
    <template #toolbar_buttons>
      <div class="flex gap-2">
        <PermissionButton :disabled="!checkedList.size" :icon="Open" :loading="btnLoading" plain round type="primary"
                          @click="batchOpen">
          批量开启
        </PermissionButton>
        <div class="custom-el-input">
          <el-select v-model="templateType" style="width: 190px">
            <template #prefix>
              <div class="flex items-center">
                <el-button bg
                           size="small" style="margin-left: -7px; font-size: 14px; border-radius: 29px;" text
                           type="success"
                           @click.stop="downloadTemplate">下载
                </el-button>
                <VerticalDivider style="margin-left: 7px" />
              </div>
            </template>
            <el-option label="商品通知模板" value="notice" />
            <el-option label="商品模板" value="product" />
            <el-option label="指导价格模板" value="price" />
          </el-select>
        </div>
        <VerticalDivider class="px-1" style="margin-left: 7px;" />

        <ImportButton :icon="Message" :uploadFunction="api.uploadChangeNotice" bg text>变更通知导入</ImportButton>
        <ImportButton :uploadFunction="api.uploadProducts" bg text>
          <i class="bi bi-box-seam mr-3"></i>
          商品导入
        </ImportButton>
        <ImportButton :icon="Money" :uploadFunction="api.uploadPrice" bg text>指导价格导入</ImportButton>
      </div>
    </template>
    <!-- 工具栏右侧 -->
    <template #toolbar_tools>
      <el-button circle class="toolbar-btn" @click="handleRefresh">
        <el-icon>
          <Refresh />
        </el-icon>
      </el-button>
      <el-button circle class="mr-3 toolbar-btn" @click="handleDownload">
        <el-icon>
          <Download />
        </el-icon>
      </el-button>
    </template>
    <template #top>
      <div class="mb-2"></div>
    </template>
    <!-- 分页 -->
    <template #pager>
      <vxe-pager
          v-model:currentPage="gridOptions.pagerConfig.page"
          v-model:pageSize="gridOptions.pagerConfig.limit"
          :total="gridOptions.pagerConfig.total"
          class="mt-1.5"
          @page-change="handlePageChange"
      />
    </template>
    <!-- 自定义列插槽 -->
    <template v-for="col in productColumns" #[`${col.field}`]="{ row }">
      <DataTableSlot :key="row.id" :field="col.field" :row="row" @edit-row="handleEdit" @handle-notice="handleNotice"
                     @handle-monitor="switchMonitor" />
    </template>
  </vxe-grid>
  <EditDrawer v-if="editOpen" v-model="editOpen" :row-data="rowData" @refresh="handleRefresh" />
  <NoticeDialog v-if="dialogVisible" v-model="dialogVisible" :row-data="rowData" />
</template>

<style scoped>
.toolbar-btn {
  width: 34px;
  height: 34px;
  font-size: 18px
}

:deep(.custom-el-input .el-select__wrapper) {
  border-radius: 20px;
}
</style>
